"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ProteinVariantAnnotation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "position",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_1_2_0 import opencb as opencb_1_2_0

        return {
            "features": opencb_1_2_0.ProteinFeature,
            "substitutionScores": opencb_1_2_0.Score,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_1_2_0 import opencb as opencb_1_2_0

        return {
            "org.opencb.biodata.models.variant.avro.ProteinFeature": opencb_1_2_0.ProteinFeature,
            "org.opencb.biodata.models.variant.avro.Score": opencb_1_2_0.Score,
            "org.opencb.biodata.models.variant.avro.ProteinVariantAnnotation": opencb_1_2_0.ProteinVariantAnnotation,
        }

    __slots__ = [
        "position",
        "alternate",
        "features",
        "functionalDescription",
        "keywords",
        "reference",
        "substitutionScores",
        "uniprotAccession",
        "uniprotName",
        "uniprotVariantId",
    ]

    def __init__(
        self,
        position,
        alternate=None,
        features=None,
        functionalDescription=None,
        keywords=None,
        reference=None,
        substitutionScores=None,
        uniprotAccession=None,
        uniprotName=None,
        uniprotVariantId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_2_0.ProteinVariantAnnotation model.

        :param position:
        :type position: int
        :param alternate:
        :type alternate: None | str
        :param features:
        :type features: None | list[ProteinFeature]
        :param functionalDescription:
        :type functionalDescription: None | str
        :param keywords:
        :type keywords: None | list[str]
        :param reference:
        :type reference: None | str
        :param substitutionScores:
        :type substitutionScores: None | list[Score]
        :param uniprotAccession:
        :type uniprotAccession: None | str
        :param uniprotName:
        :type uniprotName: None | str
        :param uniprotVariantId:
        :type uniprotVariantId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.0"
